OpenTTD

Public Member Functions | Data Fields
Ship Struct Reference

All ships have this type. More...

`#include <ship.h>`

Inheritance diagram for Ship:

## Public Member Functions
| Ship ()
| We don't want GCC to zero our struct! It already is zeroed and has an index!
virtual | ~Ship ()
| We want to 'destruct' the right class. More...
void | MarkDirty ()
| Marks the vehicles to be redrawn and updates cached variables. More...
void | UpdateDeltaXY (Direction direction)
| Updates the x and y offsets and the size of the sprite used for this vehicle. More...
ExpensesType | GetExpenseType (bool income) const
| Sets the expense type associated to this vehicle type. More...
void | PlayLeaveStationSound () const
| Play the sound associated with leaving the station.
bool | IsPrimaryVehicle () const
| Whether this is the primary vehicle in the chain.
void | GetImage (Direction direction, EngineImageType image_type, VehicleSpriteSeq *result) const
| Gets the sprite to show for the given direction. More...
int | GetDisplaySpeed () const
| Gets the speed in km-ish/h that can be sent into SetDParam for string processing. More...
int | GetDisplayMaxSpeed () const
| Gets the maximum speed in km-ish/h that can be sent into SetDParam for string processing. More...
int | GetCurrentMaxSpeed () const
| Calculates the maximum speed of the vehicle under its current conditions. More...
Money | GetRunningCost () const
| Gets the running cost of a vehicle. More...
bool | IsInDepot () const
| Check whether the vehicle is in the depot. More...
bool | Tick ()
| Calls the tick handler of the vehicle. More...
void | OnNewDay ()
| Calls the new day handler of the vehicle.
Trackdir | GetVehicleTrackdir () const
| Returns the Trackdir on which the vehicle is currently located. More...
TileIndex | GetOrderStationLocation (StationID station)
| Determine the location for the station where the vehicle goes to next. More...
bool | FindClosestDepot (TileIndex *location, DestinationID *destination, bool *reverse)
| Find the closest depot for this vehicle and tell us the location, DestinationID and whether we should reverse. More...
void | UpdateCache ()
| Update the caches of this ship.
Public Member Functions inherited from SpecializedVehicle< Ship, VEH_SHIP >
| SpecializedVehicle ()
| Set vehicle type correctly.
Ship * | First () const
| Get the first vehicle in the chain. More...
Ship * | Last ()
| Get the last vehicle in the chain. More...
const Ship * | Last () const
| Get the last vehicle in the chain. More...
Ship * | Next () const
| Get next vehicle in the chain. More...
Ship * | Previous () const
| Get previous vehicle in the chain. More...
Ship * | GetNextArticulatedPart ()
| Get the next part of an articulated engine. More...
Ship * | GetNextArticulatedPart () const
| Get the next part of an articulated engine. More...
Ship * | GetFirstEnginePart ()
| Get the first part of an articulated engine. More...
const Ship * | GetFirstEnginePart () const
| Get the first part of an articulated engine. More...
Ship * | GetLastEnginePart ()
| Get the last part of an articulated engine. More...
Ship * | GetNextVehicle () const
| Get the next real (non-articulated part) vehicle in the consist. More...
Ship * | GetPrevVehicle () const
| Get the previous real (non-articulated part) vehicle in the consist. More...
void | UpdateViewport (bool force_update, bool update_delta)
| Update vehicle sprite- and position caches. More...
Public Member Functions inherited from Vehicle
| Vehicle (VehicleType type=VEH_INVALID)
| Vehicle constructor. More...
void | PreDestructor ()
| Destroy all stuff that (still) needs the virtual functions to work properly.
virtual | ~Vehicle ()
| We want to 'destruct' the right class. More...
void | BeginLoading ()
| Prepare everything to begin the loading when arriving at a station. More...
void | CancelReservation (StationID next, Station *st)
| Return all reserved cargo packets to the station and reset all packets staged for transfer. More...
void | LeaveStation ()
| Perform all actions when leaving a station. More...
GroundVehicleCache * | GetGroundVehicleCache ()
| Access the ground vehicle cache of the vehicle. More...
const GroundVehicleCache * | GetGroundVehicleCache () const
| Access the ground vehicle cache of the vehicle. More...
uint16 & | GetGroundVehicleFlags ()
| Access the ground vehicle flags of the vehicle. More...
const uint16 & | GetGroundVehicleFlags () const
| Access the ground vehicle flags of the vehicle. More...
void | DeleteUnreachedImplicitOrders ()
| Delete all implicit orders which were not reached.
void | HandleLoading (bool mode=false)
| Handle the loading of the vehicle; when not it skips through dummy orders and does nothing in all other cases. More...
void | GetConsistFreeCapacities (SmallMap< CargoID, uint > &capacities) const
| Get a map of cargoes and free capacities in the consist. More...
uint | GetConsistTotalCapacity () const
uint | GetOldAdvanceSpeed (uint speed)
| Determines the effective direction-specific vehicle movement speed. More...
uint | GetAdvanceDistance ()
| Determines the vehicle "progress" needed for moving a step. More...
const Engine * | GetEngine () const
| Retrieves the engine of the vehicle. More...
const GRFFile * | GetGRF () const
| Retrieve the NewGRF the vehicle is tied to. More...
uint32 | GetGRFID () const
| Retrieve the GRF ID of the NewGRF the vehicle is tied to. More...
void | InvalidateNewGRFCache ()
| Invalidates cached NewGRF variables. More...
void | InvalidateNewGRFCacheOfChain ()
| Invalidates cached NewGRF variables of all vehicles in the chain (after the current vehicle) More...
bool | IsGroundVehicle () const
| Check if the vehicle is a ground vehicle. More...
virtual bool | IsChainInDepot () const
| Check whether the whole vehicle chain is in the depot. More...
bool | IsStoppedInDepot () const
| Check whether the vehicle is in the depot and stopped. More...
virtual uint | Crash (bool flooded=false)
| Crash the (whole) vehicle chain. More...
Money | GetDisplayRunningCost () const
| Gets the running cost of a vehicle that can be sent into SetDParam for string processing. More...
Money | GetDisplayProfitThisYear () const
| Gets the profit vehicle had this year. More...
Money | GetDisplayProfitLastYear () const
| Gets the profit vehicle had last year. More...
void | SetNext (Vehicle *next)
| Set the next vehicle of this vehicle. More...
Vehicle * | Next () const
| Get the next vehicle of this vehicle. More...
Vehicle * | Previous () const
| Get the previous vehicle of this vehicle. More...
Vehicle * | First () const
| Get the first vehicle of this vehicle chain. More...
Vehicle * | Last ()
| Get the last vehicle of this vehicle chain. More...
const Vehicle * | Last () const
| Get the last vehicle of this vehicle chain. More...
Vehicle * | Move (int n)
| Get the vehicle at offset n of this vehicle chain. More...
const Vehicle * | Move (int n) const
| Get the vehicle at offset n of this vehicle chain. More...
Order * | GetFirstOrder () const
| Get the first order of the vehicles order list. More...
void | AddToShared (Vehicle *shared_chain)
| Adds this vehicle to a shared vehicle chain. More...
void | RemoveFromShared ()
| Removes the vehicle from the shared order list.
Vehicle * | NextShared () const
| Get the next vehicle of the shared vehicle chain. More...
Vehicle * | PreviousShared () const
| Get the previous vehicle of the shared vehicle chain. More...
Vehicle * | FirstShared () const
| Get the first vehicle of this vehicle chain. More...
bool | IsOrderListShared () const
| Check if we share our orders with another vehicle. More...
VehicleOrderID | GetNumOrders () const
| Get the number of orders this vehicle has. More...
VehicleOrderID | GetNumManualOrders () const
| Get the number of manually added orders this vehicle has. More...
StationIDStack | GetNextStoppingStation () const
| Get the next station the vehicle will stop at. More...
void | ResetRefitCaps ()
| Reset all refit_cap in the consist to cargo_cap.
void | CopyVehicleConfigAndStatistics (const Vehicle *src)
| Copy certain configurations and statistics of a vehicle after successful autoreplace/renew The function shall copy everything that cannot be copied by a command (like orders / group etc), and that shall not be resetted for the new vehicle. More...
bool | HandleBreakdown ()
| Handle all of the aspects of a vehicle breakdown This includes adding smoke and sounds, and ending the breakdown when appropriate. More...
bool | NeedsAutorenewing (const Company *c, bool use_renew_setting=true) const
| Function to tell if a vehicle needs to be autorenewed. More...
bool | NeedsServicing () const
| Check if the vehicle needs to go to a depot in near future (if a opportunity presents itself) for service or replacement. More...
bool | NeedsAutomaticServicing () const
| Checks if the current order should be interrupted for a service-in-depot order. More...
CommandCost | SendToDepot (DoCommandFlag flags, DepotCommand command)
| Send this vehicle to the depot using the given command(s). More...
void | UpdateVisualEffect (bool allow_power_change=true)
| Update the cached visual effect. More...
void | ShowVisualEffect () const
| Draw visual effects (smoke and/or sparks) for a vehicle chain. More...
void | UpdatePosition ()
| Update the position of the vehicle. More...
void | UpdateViewport (bool dirty)
| Update the vehicle on the viewport, updating the right hash and setting the new coordinates. More...
void | UpdatePositionAndViewport ()
| Update the position of the vehicle, and update the viewport.
void | MarkAllViewportsDirty () const
| Marks viewports dirty where the vehicle's image is.
uint16 | GetServiceInterval () const
void | SetServiceInterval (uint16 interval)
bool | ServiceIntervalIsCustom () const
bool | ServiceIntervalIsPercent () const
void | SetServiceIntervalIsCustom (bool on)
void | SetServiceIntervalIsPercent (bool on)
void | IncrementImplicitOrderIndex ()
| Increments cur_implicit_order_index, keeps care of the wrap-around and invalidates the GUI. More...
void | IncrementRealOrderIndex ()
| Advanced cur_real_order_index to the next real order, keeps care of the wrap-around and invalidates the GUI. More...
void | UpdateRealOrderIndex ()
| Skip implicit orders until cur_real_order_index is a non-implicit order.
Order * | GetOrder (int index) const
| Returns order 'index' of a vehicle or NULL when it doesn't exists. More...
Order * | GetLastOrder () const
| Returns the last order of a vehicle, or NULL if it doesn't exists. More...
bool | IsEngineCountable () const
| Check if a vehicle is counted in num_engines in each company struct. More...
bool | HasEngineType () const
| Check whether Vehicle::engine_type has any meaning. More...
bool | HasDepotOrder () const
| Checks if a vehicle has a depot in its order list. More...
void | HandlePathfindingResult (bool path_found)
| Handle the pathfinding result, especially the lost status. More...
bool | IsFrontEngine () const
| Check if the vehicle is a front engine. More...
bool | IsArticulatedPart () const
| Check if the vehicle is an articulated part of an engine. More...
bool | HasArticulatedPart () const
| Check if an engine has an articulated part. More...
Vehicle * | GetNextArticulatedPart () const
| Get the next part of an articulated engine. More...
Vehicle * | GetFirstEnginePart ()
| Get the first part of an articulated engine. More...
const Vehicle * | GetFirstEnginePart () const
| Get the first part of an articulated engine. More...
Vehicle * | GetLastEnginePart ()
| Get the last part of an articulated engine. More...
Vehicle * | GetNextVehicle () const
| Get the next real (non-articulated part) vehicle in the consist. More...
Vehicle * | GetPrevVehicle () const
| Get the previous real (non-articulated part) vehicle in the consist. More...
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >
void * | operator new (size_t size)
| Allocates space for new Titem. More...
void * | operator new (size_t size, size_t index)
| Allocates space for new Titem with given index. More...
void * | operator new (size_t size, void *ptr)
| Allocates space for new Titem at given memory address. More...
void | operator delete (void *p)
| Marks Titem as free. More...
Public Member Functions inherited from BaseConsist
void | CopyConsistPropertiesFrom (const BaseConsist *src)
| Copy properties of other BaseConsist. More...

## Data Fields
TrackBitsByte | state
| The "track" the ship is following.
Data Fields inherited from Vehicle
TileIndex | tile
| Current tile index.
TileIndex | dest_tile
| Heading for this tile. More...
Money | profit_this_year
| Profit this year << 8, low 8 bits are fract.
Money | profit_last_year
| Profit last year << 8, low 8 bits are fract.
Money | value
| Value of the vehicle.
CargoPayment * | cargo_payment
| The cargo payment we're currently in.
Rect | coord
| NOSAVE: Graphical bounding box of the vehicle, i.e. what to redraw on moves.
Vehicle * | hash_viewport_next
| NOSAVE: Next vehicle in the visual location hash.
Vehicle ** | hash_viewport_prev
| NOSAVE: Previous vehicle in the visual location hash.
Vehicle * | hash_tile_next
| NOSAVE: Next vehicle in the tile location hash.
Vehicle ** | hash_tile_prev
| NOSAVE: Previous vehicle in the tile location hash.
Vehicle ** | hash_tile_current
| NOSAVE: Cache of the current hash chain.
SpriteID | colourmap
| NOSAVE: cached colour mapping.
Year | build_year
| Year the vehicle has been built.
Date | age
| Age in days.
Date | max_age
| Maximum age.
Date | date_of_last_service
| Last date the vehicle had a service at a depot.
uint16 | reliability
| Reliability.
uint16 | reliability_spd_dec
| Reliability decrease speed.
byte | breakdown_ctr
| Counter for managing breakdown events. More...
byte | breakdown_delay
| Counter for managing breakdown length.
byte | breakdowns_since_last_service
| Counter for the amount of breakdowns.
byte | breakdown_chance
| Current chance of breakdowns.
int32 | x_pos
| x coordinate.
int32 | y_pos
| y coordinate.
int32 | z_pos
| z coordinate.
DirectionByte | direction
| facing
OwnerByte | owner
| Which company owns the vehicle?
byte | spritenum
| currently displayed sprite index 0xfd == custom sprite, 0xfe == custom second head sprite 0xff == reserved for another custom sprite
VehicleSpriteSeq | sprite_seq
| Vehicle appearance.
byte | x_extent
| x-extent of vehicle bounding box
byte | y_extent
| y-extent of vehicle bounding box
byte | z_extent
| z-extent of vehicle bounding box
int8 | x_bb_offs
| x offset of vehicle bounding box
int8 | y_bb_offs
| y offset of vehicle bounding box
int8 | x_offs
| x offset for vehicle sprite
int8 | y_offs
| y offset for vehicle sprite
EngineID | engine_type
| The type of engine used for this vehicle.
TextEffectID | fill_percent_te_id
| a text-effect id to a loading indicator object
UnitID | unitnumber
| unit number, for display purposes only
uint16 | cur_speed
| current speed
byte | subspeed
| fractional speed
byte | acceleration
| used by train & aircraft
uint32 | motion_counter
| counter to occasionally play a vehicle sound.
byte | progress
| The percentage (if divided by 256) this vehicle already crossed the tile unit.
byte | random_bits
| Bits used for determining which randomized variational spritegroups to use when drawing.
byte | waiting_triggers
| Triggers to be yet matched before rerandomizing the random bits.
StationID | last_station_visited
| The last station we stopped at.
StationID | last_loading_station
| Last station the vehicle has stopped at and could possibly leave from with any cargo loaded.
CargoID | cargo_type
| type of cargo this vehicle is carrying
byte | cargo_subtype
| Used for livery refits (NewGRF variations)
uint16 | cargo_cap
| total capacity
uint16 | refit_cap
| Capacity left over from before last refit.
VehicleCargoList | cargo
| The cargo this vehicle is carrying.
uint16 | cargo_age_counter
| Ticks till cargo is aged next.
int8 | trip_occupancy
| NOSAVE: Occupancy of vehicle of the current trip (updated after leaving a station).
byte | day_counter
| Increased by one for each day.
byte | tick_counter
| Increased by one for each tick.
byte | running_ticks
| Number of ticks this vehicle was not stopped this day.
byte | vehstatus
| Status.
Order | current_order
| The current order (+ status, like: loading)
union {
OrderList * list
| Pointer to the order list for this vehicle.
Order * old
| Only used during conversion of old save games.
} | orders
| The orders currently assigned to the vehicle.
uint16 | load_unload_ticks
| Ticks to wait before starting next cycle.
GroupID | group_id
| Index of group Pool array.
byte | subtype
| subtype (Filled with values from #EffectVehicles/#TrainSubTypes/#AircraftSubTypes)
NewGRFCache | grf_cache
| Cache of often used calculated NewGRF values.
VehicleCache | vcache
| Cache of often used vehicle values.
Data Fields inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >
Tindex | index
| Index of this pool item.
Data Fields inherited from BaseVehicle
VehicleTypeByte | type
| Type of vehicle.
Data Fields inherited from BaseConsist
char * | name
| Name of vehicle.
uint32 | current_order_time
| How many ticks have passed since this order started.
int32 | lateness_counter
| How many ticks late (or early if negative) this vehicle is.
Date | timetable_start
| When the vehicle is supposed to start the timetable.
uint16 | service_interval
| The interval for (automatic) servicing; either in days or %.
VehicleOrderID | cur_real_order_index
| The index to the current real (non-implicit) order.
VehicleOrderID | cur_implicit_order_index
| The index to the current implicit order.
uint16 | vehicle_flags
| Used for gradual loading and other miscellaneous things (. More...

## Additional Inherited Members
Public Types inherited from SpecializedVehicle< Ship, VEH_SHIP >
typedef SpecializedVehicle< Ship, Type > | SpecializedVehicleBase
| Our type.
Static Public Member Functions inherited from SpecializedVehicle< Ship, VEH_SHIP >
static bool | IsValidID (size_t index)
| Tests whether given index is a valid index for vehicle of this type. More...
static Ship * | Get (size_t index)
| Gets vehicle with given index. More...
static Ship * | GetIfValid (size_t index)
| Returns vehicle if the index is a valid index for this vehicle type. More...
static Ship * | From (Vehicle *v)
| Converts a Vehicle to SpecializedVehicle with type checking. More...
static const Ship * | From (const Vehicle *v)
| Converts a const Vehicle to const SpecializedVehicle with type checking. More...
Static Public Member Functions inherited from Vehicle
static uint | GetAdvanceSpeed (uint speed)
| Determines the effective vehicle movement speed. More...
Static Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >
static bool | CanAllocateItem (size_t n=1)
| Helper functions so we can use PoolItem::Function() instead of _poolitem_pool.Function() More...
static bool | CleaningPool ()
| Returns current state of pool cleaning - yes or no. More...
static bool | IsValidID (size_t index)
| Tests whether given index can be used to get valid (non-NULL) Titem. More...
static Titem * | Get (size_t index)
| Returns Titem with given index. More...
static Titem * | GetIfValid (size_t index)
| Returns Titem with given index. More...
static size_t | GetPoolSize ()
| Returns first unused index. More...
static size_t | GetNumItems ()
| Returns number of valid items in the pool. More...
static void | PostDestructor (size_t index)
| Dummy function called after destructor of each member. More...
Static Public Attributes inherited from SpecializedVehicle< Ship, VEH_SHIP >
static const VehicleType | EXPECTED_TYPE
| Specialized type.

## Detailed Description

All ships have this type.

Definition at line 24 of file ship.h.

## Constructor & Destructor Documentation

## ◆ ~Ship()

virtual Ship::~Ship | ( |  | ) |
| inline virtual

We want to 'destruct' the right class.

Definition at line 30 of file ship.h.

References Vehicle::direction, MarkDirty(), Vehicle::PreDestructor(), and UpdateDeltaXY().

## Member Function Documentation

## ◆ FindClosestDepot()

bool Ship::FindClosestDepot | ( | TileIndex * | location,
|  | DestinationID * | destination,
|  | bool * | reverse
| ) |  |
| virtual

Find the closest depot for this vehicle and tell us the location, DestinationID and whether we should reverse.

Parameters

  location | where do we go to?
  destination | what hangar do we go to?
  reverse | should the vehicle be reversed?

Returns
  true if a depot could be found.

Reimplemented from Vehicle.

Definition at line 715 of file ship_cmd.cpp.

Referenced by IsInDepot().

## ◆ GetCurrentMaxSpeed()

int Ship::GetCurrentMaxSpeed | ( |  | ) | const
| inline virtual

Calculates the maximum speed of the vehicle under its current conditions.

Returns
  Current maximum speed in native units.

Reimplemented from Vehicle.

Definition at line 40 of file ship.h.

References VehicleCache::cached_max_speed, GetRunningCost(), min(), and Vehicle::vcache.

## ◆ GetDisplayMaxSpeed()

int Ship::GetDisplayMaxSpeed | ( |  | ) | const
| inline virtual

Gets the maximum speed in km-ish/h that can be sent into SetDParam for string processing.

Returns
  the vehicle's maximum speed

Reimplemented from Vehicle.

Definition at line 39 of file ship.h.

References VehicleCache::cached_max_speed, and Vehicle::vcache.

## ◆ GetDisplaySpeed()

int Ship::GetDisplaySpeed | ( |  | ) | const
| inline virtual

Gets the speed in km-ish/h that can be sent into SetDParam for string processing.

Returns
  the vehicle's speed

Reimplemented from Vehicle.

Definition at line 38 of file ship.h.

References Vehicle::cur_speed.

## ◆ GetExpenseType()

ExpensesType Ship::GetExpenseType | ( | bool | income | ) | const
| inline virtual

Sets the expense type associated to this vehicle type.

Parameters

  income | whether this is income or (running) expenses of the vehicle

Reimplemented from Vehicle.

Definition at line 34 of file ship.h.

References EXPENSES_SHIP_INC, EXPENSES_SHIP_RUN, and PlayLeaveStationSound().

## ◆ GetImage()

void Ship::GetImage | ( | Direction | direction,
|  | EngineImageType | image_type,
|  | VehicleSpriteSeq * | result
| ) |  | const
| virtual

Gets the sprite to show for the given direction.

Parameters

  | direction | the direction the vehicle is facing
  [out] | result | Vehicle sprite sequence.

Reimplemented from Vehicle.

Definition at line 127 of file ship_cmd.cpp.

References Vehicle::spritenum.

Referenced by IsPrimaryVehicle().

## ◆ GetOrderStationLocation()

TileIndex Ship::GetOrderStationLocation | ( | StationID | station | ) |
| virtual

Determine the location for the station where the vehicle goes to next.

Things done for example are allocating slots in a road stop or exact location of the platform is determined for ships.

Parameters

  station | the station to make the next location of the vehicle.

Returns
  the location (tile) to aim for.

Reimplemented from Vehicle.

Definition at line 286 of file ship_cmd.cpp.

References Vehicle::last_station_visited.

Referenced by IsInDepot().

## ◆ GetRunningCost()

Money Ship::GetRunningCost | ( |  | ) | const
| virtual

Gets the running cost of a vehicle.

Returns
  the vehicle's running cost

Reimplemented from Vehicle.

Definition at line 217 of file ship_cmd.cpp.

References Vehicle::GetEngine().

Referenced by GetCurrentMaxSpeed().

## ◆ GetVehicleTrackdir()

Trackdir Ship::GetVehicleTrackdir | ( |  | ) | const
| virtual

Returns the Trackdir on which the vehicle is currently located.

Works for trains and ships. Currently works only sortof for road vehicles, since they have a fuzzy concept of being "on" a trackdir. Dunno really what it returns for a road vehicle that is halfway a tile, never really understood that part. For road vehicles that are at the beginning or end of the tile, should just return the diagonal trackdir on which they are driving. I think. For other vehicles types, or vehicles with no clear trackdir (such as those in depots), returns 0xFF.

Returns
  the trackdir of the vehicle

Reimplemented from Vehicle.

Definition at line 250 of file ship_cmd.cpp.

References DiagDirToDiagTrackdir(), Vehicle::direction, DirToDiagDir(), FindFirstTrack(), GetShipDepotDirection(), INVALID_TRACKDIR, IsInDepot(), state, Vehicle::tile, TRACK_BIT_WORMHOLE, TrackDirectionToTrackdir(), Vehicle::vehstatus, and VS_CRASHED.

Referenced by IsInDepot(), NPFShipChooseTrack(), CYapfFollowShipT< Types >::TransportTypeChar(), and YapfShipCheckReverse().

## ◆ IsInDepot()

bool Ship::IsInDepot | ( |  | ) | const
| inline virtual

Check whether the vehicle is in the depot.

Returns
  true if and only if the vehicle is in the depot.

Reimplemented from Vehicle.

Definition at line 42 of file ship.h.

References FindClosestDepot(), GetOrderStationLocation(), GetVehicleTrackdir(), OnNewDay(), Tick(), TRACK_BIT_DEPOT, and UpdateCache().

Referenced by GetVehicleTrackdir().

## ◆ MarkDirty()

void Ship::MarkDirty | ( |  | ) |
| virtual

Marks the vehicles to be redrawn and updates cached variables.

This method marks the area of the vehicle on the screen as dirty. It can be use to repaint the vehicle.

Reimplemented from Vehicle.

Definition at line 267 of file ship_cmd.cpp.

References Vehicle::colourmap.

Referenced by ~Ship().

## ◆ Tick()

bool Ship::Tick | ( |  | ) |
| virtual

Calls the tick handler of the vehicle.

Returns
  is this vehicle still valid?

Reimplemented from Vehicle.

Definition at line 635 of file ship_cmd.cpp.

References Vehicle::running_ticks, Vehicle::vehstatus, and VS_STOPPED.

Referenced by IsInDepot().

## ◆ UpdateDeltaXY()

void Ship::UpdateDeltaXY | ( | Direction | direction | ) |
| virtual

Updates the x and y offsets and the size of the sprite used for this vehicle.

Parameters

  direction | the direction the vehicle is facing

Reimplemented from Vehicle.

Definition at line 299 of file ship_cmd.cpp.

References Vehicle::direction, Vehicle::x_extent, Vehicle::x_offs, Vehicle::y_extent, Vehicle::y_offs, and Vehicle::z_extent.

Referenced by ~Ship().

The documentation for this struct was generated from the following files:

- src/ship.h
- src/ship_cmd.cpp